<template>
  <v-container fluid>
    <v-row>
      <v-col class="fixed-bar">
        <div class="text-center">
          <img src="/logopokemon.png" alt="Logo" width="300" />
        </div>
        <v-text-field
          label=""
          variant="outlined"
          v-model="sPokemon"
          :loading="loading"
          placeholder="Busca aquí tu pokemon"
          type="search"
          hint="Escribe el nombre del pokemón lo demás lo haremos nosotros :)"
          clearable
          density="compact"
        />
      </v-col>
    </v-row>
    <v-skeleton-loader
      v-if="loading"
      boilerplate
      class="mx-auto"
      elevation="2"
      type="card-avatar, article, actions"
    />
    <div v-else>
      <v-row v-if="cmpPokemons && cmpPokemons.length != 0" :key="nKey">
        <v-col 
          :cols="$vuetify.breakpoint.xs ? 12 : 3"
          v-for="(item, index) in cmpPokemons" 
          :key="index">
          <Pokemon
            :title="item.name"
            :img="item.cover"
            :key="`${index}__`"
            @onMoreInformation="onMoreInformation"
          />
        </v-col>
      </v-row>
      <v-row v-else>
        <v-col>
          <v-alert color="success" elevation="2" icon="mdi-vuejs">
            Lo sentimos <v-icon>mdi-emoticon-sad-outline</v-icon>, No hemos
            encontrado ningun dato que similar a tu busqueda. Puedes intentar
            con otro nombre.
          </v-alert>
        </v-col>
      </v-row>
    </div>
    <v-btn block color="grey" @click="onGetNextItems()" class="mt-3">
      <v-icon>mdi-package-down</v-icon> {{ isLoadingNext ? 'Cargando' : 'Cargar más' }}
    </v-btn>
    <div v-if="isLoadingNext">
      Cargando...
      <v-skeleton-loader        
        boilerplate
        class="mx-auto mt-3"
        elevation="5"
        type="article"
      />
    </div>
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      small
      bottom
      right
      color="primary"
      @click="$vuetify.goTo(0)"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <InfoPokemon ref="info" />
  </v-container>
</template>
<script>
import Pokemon from "@/components/pokemon/Pokemon.vue";
import InfoPokemon from "@/components/pokemon/PokemonDetails.vue";
import axios from "axios";
export default {
  components: {
    Pokemon,
    InfoPokemon,
  },
  data() {
    return {
      pokemons: [],
      limit: 20,
      next: "",
      loading: false,
      sPokemon: "",
      isLoadingNext: false,
      nKey: 0,
      fab: false,
    };
  },
  computed: {
    cmpPokemons() {
      //   Si la variable es null o vacio devuelvo el array por completo
      if (this.sPokemon == "" || !this.sPokemon) return this.pokemons;
      //   creo una constante que convierte a minusculas el valor buscado
      const sFiltro = this.sPokemon.toLowerCase();
      //   se realiza filtro con la información escrita, validando en ambos casos por minusculas
      return this.pokemons.filter((item) =>
        item.name.toLowerCase().includes(sFiltro)
      );
    },
  },
  mounted() {
    this.onGetItems();
    // window.addEventListener("scroll", this.handleScroll);
  },
   beforeUnmount() {
    window.removeEventListener('resize', this.handleResize);
  },
  beforeDestroy() {
    window.removeEventListener("scroll", this.handleScroll);
  },
  methods: {
    onScroll (e) {
      if (typeof window === 'undefined') return
      const top = window.pageYOffset ||   e.target.scrollTop || 0
      this.fab = top > 20
    },
    onMoreInformation(data) {
      const info = this.$refs.info;
      info.show = true;
      if(data) {
        // Filtramos por el id seleccionado en el array de pokemons
        const oPokemon = this.pokemons.find((item) => item.name.toLowerCase() === data.toLowerCase());
        if(oPokemon !== -1) {
          info.oPokemon = oPokemon;
          console.log(oPokemon);
        }
      }
    },
    async onGetItems() {
      try {
        this.loading = true;
        const {
          data: { next, results }
        } = await axios.get(`pokemon?limit=${this.limit}&offset=0`);
        this.next = next;
        this.pokemons = results;
        await Promise.all(
          results.map(async (oItem) => {
            const { data } = await axios.get(`pokemon/${oItem.name}`);
            oItem.cover = data.sprites.other.dream_world.front_default;
            oItem.details = data;
          })
        );
        this.loading = false;
      } catch (error) {
        this.loading = false;
        console.log(error);
      }
    },
    // Usamos esta función al realizar la implementación del scroll
    async onGetNextItems() {
      // code
      try {
        if (this.next) {
          const nextUrl = this.next;
          const {
            data: { next, results },
          } = await axios.get(nextUrl);
          this.next = next;
          this.pokemons.push(...results);
          await Promise.all(
            this.pokemons.map(async (oItem) => {
              const { data } = await axios.get(`pokemon/${oItem.name}`);
              oItem.cover = data.sprites.other.dream_world.front_default;
              oItem.details = data;
            })
          );
          this.isLoadingNext = false;
          this.nKey++;
        }
      } catch (error) {
        this.isLoadingNext = false;
        error;
      }
    },
  },
};
</script>
<style scoped>
.fixed-bar {
  position: sticky;
  position: -webkit-sticky; /* for Safari */
  top: 6em;
  z-index: 2;
}
</style>